Index: java/main/src/main/java/com/framsticks/core/TreeOperations.java
===================================================================
--- java/main/src/main/java/com/framsticks/core/TreeOperations.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/core/TreeOperations.java	(revision 100)
@@ -8,13 +8,17 @@
 import javax.annotation.Nonnull;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.communication.File;
-import com.framsticks.params.AccessInterface;
+import com.framsticks.params.Access;
+import com.framsticks.params.CompositeParam;
 import com.framsticks.params.EventListener;
 import com.framsticks.params.FramsClass;
 import com.framsticks.params.ListAccess;
 import com.framsticks.params.Param;
+import com.framsticks.params.ParamBuilder;
 import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.PropertiesAccess;
 import com.framsticks.params.UniqueListAccess;
 import com.framsticks.params.Util;
@@ -25,4 +29,5 @@
 import com.framsticks.parsers.MultiParamLoader;
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.Future;
 import com.framsticks.util.dispatching.FutureHandler;
@@ -33,103 +38,124 @@
 public final class TreeOperations {
 
-	private static final Logger log = Logger.getLogger(TreeOperations.class);
+	private static final Logger log = LogManager.getLogger(TreeOperations.class);
 
 	private TreeOperations() {
 	}
 
+	public static final Object FETCHED_MARK = new Object();
+
 	public static @Nonnull FramsClass processFetchedInfo(Tree tree, File file) {
 		assert tree.isActive();
 		FramsClass framsClass = Loaders.loadFramsClass(file.getContent());
-		log.debug("process fetched info for " + tree + ": " + framsClass);
+		log.debug("process fetched info for {}: {}", tree, framsClass);
 		tree.putInfoIntoCache(framsClass);
 		return framsClass;
 	}
 
-	public static void processFetchedValues(Path path, List<File> files) {
-		Tree tree = path.getTree();
-		assert tree.isActive();
+	public static Path create(Path path) {
+		assert !path.isResolved();
+
+		Access access = path.getTree().prepareAccess(path.getTop().getParam());
+		Object child = createAccessee(path.getTree(), access);
+		assert child != null;
+		if (path.size() == 1) {
+			path.getTree().assignRootObject(child);
+		} else {
+			Access parentAccess = bindAccess(path.getUnder());
+
+			/** this special case is not very good - maybe hide it in createAccessee? */
+			if (parentAccess instanceof UniqueListAccess) {
+				access.select(child);
+				access.set(((UniqueListAccess) parentAccess).getUidName(), path.getTop().getParam().getId());
+			}
+
+			parentAccess.set(path.getTop().getParam(), child);
+		}
+		path = path.appendResolution(child);
+		return path;
+	}
+
+	public static void processFetchedValues(final Path path, final List<File> files, final Access access, final Future<Path> future) {
 		assert files.size() == 1;
 		assert path.isTheSame(files.get(0).getPath());
 
-		if (!path.isResolved()) {
-			AccessInterface access = tree.prepareAccess(path.getTop().getParam());
-			Object child = access.createAccessee();
-			assert child != null;
-			if (path.size() == 1) {
-				tree.assignRootObject(child);
-			} else {
-				bindAccess(path.getUnder()).set(path.getTop().getParam(), child);
-			}
-			path = path.appendResolution(child);
-		}
-
-		log.debug("process fetched values: " + path);
-		Node node = path.getTop();
-		MultiParamLoader loader = new MultiParamLoader();
-		loader.setNewSource(files.get(0).getContent());
-		loader.addBreakCondition(MultiParamLoader.Status.AfterObject);
 
 		try {
-			if (node.getParam() instanceof ObjectParam) {
-				loader.addAccessInterface(bindAccess(node));
-				loader.go();
-				return;
-			}
-
-			ListAccess listAccess = (ListAccess) bindAccess(node);
-
-			Set<String> oldValuesIds = new HashSet<>();
-			for (Param p : listAccess.getParams()) {
-				oldValuesIds.add(p.getId());
-			}
-
-			// listAccess.clearValues();
-
-			AccessInterface elementAccess = listAccess.getElementAccess();
-			AccessInterface clonerInterface = elementAccess.cloneAccess();
-
-			loader.addAccessInterface(elementAccess);
-			MultiParamLoader.Status status;
-			int number = 0;
-			while ((status = loader.go()) != MultiParamLoader.Status.Finished) {
-				if (status == MultiParamLoader.Status.AfterObject) {
-					AccessInterface accessInterface = loader.getLastAccessInterface();
-
-					String id;
-					if (listAccess instanceof UniqueListAccess) {
-						id = ((UniqueListAccess) listAccess).computeIdentifierFor(accessInterface.getSelected());
-					} else {
-						id = Integer.toString(number);
-					}
-					++number;
-
-					Object childTo = listAccess.get(id, Object.class);
-					boolean newOne;
-					if (childTo == null) {
-						childTo = clonerInterface.createAccessee();
-						newOne = true;
-					} else {
-						assert oldValuesIds.contains(id);
-						newOne = false;
-					}
-					oldValuesIds.remove(id);
-					clonerInterface.select(childTo);
-					Util.takeAllNonNullValues(clonerInterface, accessInterface);
-					if (newOne) {
-						listAccess.set(id, childTo);
-					}
-
-					// listAccess.set(id, accessInterface.getSelected());
-					accessInterface.select(null);
-
+			log.debug("process fetched values: {}", path);
+			final Access parsingAccess = new PropertiesAccess(access.getFramsClass());
+			final List<Object> results = MultiParamLoader.loadAll(files.get(0).getContent(), parsingAccess);
+
+			Dispatching.dispatchIfNotActive(path.getTree(), new RunAt<Tree>(future) {
+				@Override
+				protected void runAt() {
+
+					Path result = path.tryResolveIfNeeded();
+
+					if (!result.isResolved()) {
+						result = create(result);
+					}
+
+					if (path.getTop().getParam() instanceof ObjectParam) {
+						assert results.size() == 1;
+						Util.takeAllNonNullValues(bindAccess(result), parsingAccess.select(results.get(0)));
+						mark(result.getTree(), result.getTopObject(), FETCHED_MARK, true);
+						future.pass(result);
+						return;
+					}
+
+
+					final ListAccess listAccess = (ListAccess) access;
+
+					listAccess.select(result.getTopObject());
+					Set<String> oldValuesIds = new HashSet<>();
+					for (Param p : listAccess.getParams()) {
+						oldValuesIds.add(p.getId());
+					}
+
+					Access targetAccess = listAccess.getElementAccess();//.cloneAccess();
+
+					int number = 0;
+					for (Object r : results) {
+
+						parsingAccess.select(r);
+						String id;
+						if (listAccess instanceof UniqueListAccess) {
+							id = parsingAccess.get(((UniqueListAccess) listAccess).getUidName(), String.class);
+						} else {
+							id = Integer.toString(number);
+						}
+						++number;
+
+						Object childTo = listAccess.get(id, Object.class);
+						boolean newOne;
+						if (childTo == null) {
+							childTo = createAccessee(result.getTree(), targetAccess);
+							newOne = true;
+						} else {
+							assert oldValuesIds.contains(id);
+							newOne = false;
+						}
+						oldValuesIds.remove(id);
+
+						targetAccess.select(childTo);
+						Util.takeAllNonNullValues(targetAccess, parsingAccess);
+						if (newOne) {
+							listAccess.set(id, childTo);
+						}
+						mark(result.getTree(), childTo, FETCHED_MARK, true);
+
+					}
+					mark(result.getTree(), result.getTopObject(), FETCHED_MARK, true);
+
+					/** It looks tricky for ArrayListAccess but should also work.
+					 *
+					 * They should be sorted.
+					 */
+					for (String id : oldValuesIds) {
+						listAccess.set(id, null);
+					}
+					future.pass(result);
 				}
-			}
-			/** It looks tricky for ArrayListAccess but should also work.
- 			 *
-			 * They should be sorted.
-			 */
-			for (String id : oldValuesIds) {
-				listAccess.set(id, null);
-			}
+			});
 
 		} catch (FramsticksException e) {
@@ -141,5 +167,5 @@
 		Tree tree = path.getTree();
 		assert tree.isActive();
-		log.debug("get info for: " + path);
+		log.debug("get info for: {}", path);
 		final String name = path.getTop().getParam().getContainedTypeName();
 		return tree.getInfoFromCache(name);
@@ -147,5 +173,5 @@
 
 	public static void findInfo(final Path path, final Future<FramsClass> future) {
-		log.debug("find info for: " + path);
+		log.debug("find info for: {}", path);
 		try {
 			Tree tree = path.getTree();
@@ -163,11 +189,18 @@
 
 
-
-	public static @Nonnull AccessInterface bindAccess(Tree tree, String path) {
-		log.debug("bind access for textual: " + path + " in " + tree);
+	public static @Nonnull Access bindAccessFromSideNote(Tree tree, Object object) {
+		CompositeParam param = tree.getSideNote(object, CompositeParam.class, CompositeParam.class);
+		if (param == null) {
+			throw new FramsticksException().msg("failed to bind access from side node").arg("tree", tree).arg("object", object).arg("type", object.getClass());
+		}
+		return tree.prepareAccess(param).select(object);
+	}
+
+	public static @Nonnull Access bindAccess(Tree tree, String path) {
+		log.debug("bind access for textual: {} in {}", path, tree);
 		return bindAccess(Path.to(tree, path));
 	}
 
-	public static @Nonnull AccessInterface bindAccess(Node node) {
+	public static @Nonnull Access bindAccess(Node node) {
 		Tree tree = node.getTree();
 		assert tree.isActive();
@@ -175,15 +208,18 @@
 
 		try {
-			return tree.prepareAccess(node.getParam()).select(node.getObject());
+			Access access = tree.prepareAccess(node.getParam());
+			tree.putSideNote(node.getObject(), CompositeParam.class, node.getParam());
+
+			return access.select(node.getObject());
 		} catch (FramsticksException e) {
 			throw new FramsticksException().msg("failed to prepare access for param").arg("param", node.getParam()).cause(e);
-			// log.error("failed to bind access for " + node.getParam() + ": " + e);
-		}
-	}
-
-	public static @Nonnull AccessInterface bindAccess(Path path) {
+			// log.error("failed to bind access for {}: ", node.getParam(), e);
+		}
+	}
+
+	public static @Nonnull Access bindAccess(Path path) {
 		assert path.getTree().isActive();
 		path.assureResolved();
-		log.debug("bind access for: " + path);
+		log.debug("bind access for: {}", path);
 		return bindAccess(path.getTop());
 	}
@@ -196,4 +232,16 @@
 			protected void runAt() {
 				tree.set(path, param, value, future);
+			}
+		});
+	}
+
+	public static void call(final Path path, final String procedureName, final Object[] arguments, final Future<Object> future) {
+		final Tree tree = path.getTree();
+
+		dispatchIfNotActive(tree, new RunAt<Tree>(future) {
+			@Override
+			protected void runAt() {
+				path.assureResolved();
+				tree.call(path, tree.getRegistry().getFramsClass(path.getTop().getParam()).getParamEntry(procedureName, ProcedureParam.class), arguments, future);
 			}
 		});
@@ -241,5 +289,5 @@
 	 * */
 	public static void tryGet(final Tree tree, final String targetPath, final Future<Path> future) {
-		log.debug("resolve textual: " + targetPath + " for " + tree);
+		log.debug("resolve textual: {} for {}", targetPath, tree);
 		dispatchIfNotActive(tree, new RunAt<Tree>(future) {
 
@@ -247,5 +295,5 @@
 			protected void runAt() {
 				final Path path = Path.tryTo(tree, targetPath).tryResolveIfNeeded();
-				log.debug("found: " + path);
+				log.debug("found: {}", path);
 				if (path.isResolved()) {
 					future.pass(path);
@@ -257,8 +305,8 @@
 					protected void result(Path result) {
 						// if (result.isResolved(targetPath)) {
-						// 	future.pass(result);
-						// 	return;
+						//	future.pass(result);
+						//	return;
 						// }
-						log.debug("retrying resolve textual: " + targetPath + " for " + tree + " with " + result);
+						log.debug("retrying resolve textual: {} for {} with {}", targetPath, tree, result);
 						tryGet(tree, targetPath, future);
 					}
@@ -273,3 +321,30 @@
 	}
 
+	public static Object createAccessee(Tree tree, CompositeParam param) {
+		Object object = tree.prepareAccess(param).createAccessee();
+		tree.putSideNote(object, CompositeParam.class, param);
+		return object;
+	}
+
+	public static Object createAccessee(Tree tree, Access access) {
+		Object object = access.createAccessee();
+		tree.putSideNote(object, CompositeParam.class, access.buildParam(new ParamBuilder()).finish(CompositeParam.class));
+		return object;
+	}
+
+	public static boolean isMarked(Tree tree, Object object, Object mark, boolean defValue) {
+		assert tree.isActive();
+		Boolean v = tree.getSideNote(object, mark, Boolean.class);
+		return (v != null ? v : defValue);
+	}
+
+	public static void mark(Tree tree, Object object, Object mark, boolean value) {
+		assert tree.isActive();
+		tree.putSideNote(object, mark, value);
+	}
+
+	public static FramsClass getFramsClass(Path path) {
+		return path.getTree().getRegistry().getFramsClass(path.getTop().getParam());
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java
===================================================================
--- java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/diagnostics/Diagnostics.java	(revision 100)
@@ -40,5 +40,5 @@
 		// 					@Override
 		// 					public void handle(FramsticksException exception) {
-		// 						log.error("caught error during diagnostics fetching (repeating): " + exception);
+		// 						log.error("caught error during diagnostics fetching (repeating): {}", exception);
 		// 						again();
 		// 					}
Index: java/main/src/main/java/com/framsticks/dumping/LoadStream.java
===================================================================
--- java/main/src/main/java/com/framsticks/dumping/LoadStream.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/dumping/LoadStream.java	(revision 100)
@@ -10,5 +10,6 @@
 import com.framsticks.util.lang.Pair;
 import com.framsticks.util.lang.Strings;
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import java.io.BufferedReader;
@@ -22,5 +23,5 @@
 public class LoadStream extends Stream {
 
-	private final static Logger log = Logger.getLogger(LoadStream.class.getName());
+	private final static Logger log = LogManager.getLogger(LoadStream.class.getName());
 
 	protected final Tree tree;
@@ -49,5 +50,5 @@
 					query = Strings.splitIntoPair(line, ' ', "");
 					files = new LinkedList<File>();
-					log.trace("loading " + line);
+					log.trace("loading {}", line);
 					continue;
 				}
@@ -84,9 +85,9 @@
 			}
 		} catch (IOException e) {
-			log.error("failed to load: " + e);
+			log.error("failed to load: {}", e);
 			future.handle(new FramsticksException().msg("failed to load stream").cause(e));
 			return;
 		}
-		log.info("loaded in: " + stopwatch);
+		log.info("loaded in: {}", stopwatch);
 		future.pass(Path.to(tree, mountPath.getTextual()));
 	}
Index: java/main/src/main/java/com/framsticks/dumping/SaveStream.java
===================================================================
--- java/main/src/main/java/com/framsticks/dumping/SaveStream.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/dumping/SaveStream.java	(revision 100)
@@ -4,5 +4,5 @@
 import com.framsticks.core.Node;
 import com.framsticks.core.Path;
-import com.framsticks.params.AccessInterface;
+import com.framsticks.params.Access;
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.FramsClass;
@@ -15,5 +15,6 @@
 import com.framsticks.util.dispatching.Future;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 import com.framsticks.util.dispatching.RunAt;
 
@@ -27,5 +28,5 @@
 public class SaveStream extends Stream {
 
-	private final static Logger log = Logger.getLogger(SaveStream.class.getName());
+	private final static Logger log = LogManager.getLogger(SaveStream.class.getName());
 
 	protected final SinkInterface sink;
@@ -57,5 +58,5 @@
 	protected void finished() {
 		assert tree.isActive();
-		log.info("stored in " + stopwatch);
+		log.info("stored in {}", stopwatch);
 		future.pass(null);
 	}
@@ -64,7 +65,7 @@
 		assert tree.isActive();
 		if (!path.isResolved()) {
-			log.debug("path " + path + " is not resolved - skipping");
+			log.debug("path {} is not resolved - skipping", path);
 		} else {
-			AccessInterface access = bindAccess(path);
+			Access access = bindAccess(path);
 			assert access != null;
 			FramsClass framsClass = access.getFramsClass();
Index: java/main/src/main/java/com/framsticks/gui/AbstractPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/AbstractPanel.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/AbstractPanel.java	(revision 100)
@@ -0,0 +1,53 @@
+package com.framsticks.gui;
+
+import java.util.concurrent.atomic.AtomicInteger;
+
+import javax.swing.*;
+
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+
+import com.framsticks.gui.tree.AbstractNode;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+@SuppressWarnings("serial")
+public abstract class AbstractPanel extends JPanel {
+
+	private static final Logger log = LogManager.getLogger(AbstractPanel.class);
+
+	protected final Frame frame;
+
+	protected final String uniqueName;
+	protected final static AtomicInteger counter = new AtomicInteger();
+
+	/**
+	 * @param frame
+	 */
+	public AbstractPanel(Frame frame) {
+		this.frame = frame;
+		this.uniqueName = "panel_" + counter.getAndIncrement();
+
+		frame.cardPanel.add(this, uniqueName);
+		frame.cardPanelLayout.addLayoutComponent(this, uniqueName);
+		log.debug("created panel {}", uniqueName);
+	}
+
+	public final Frame getFrame() {
+		return frame;
+	}
+
+	public abstract String getTitle();
+
+	public final String getUniqueName() {
+		return uniqueName;
+	}
+
+	public abstract void fillPanelWith(AbstractNode node);
+
+	@Override
+	public String toString() {
+		return uniqueName;
+	}
+}
Index: java/main/src/main/java/com/framsticks/gui/Browser.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/Browser.java	(revision 100)
@@ -23,5 +23,6 @@
 import javax.swing.*;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import java.awt.Dimension;
@@ -40,5 +41,5 @@
 public class Browser extends AbstractJoinable implements Dispatcher<Browser>, JoinableParent, ExceptionResultHandler {
 
-	private static final Logger log = Logger.getLogger(Browser.class);
+	private static final Logger log = LogManager.getLogger(Browser.class);
 
 	protected final JoinableCollection<Frame> frames = new JoinableCollection<Frame>().setObservableName("frames");
@@ -117,5 +118,5 @@
 	@AutoAppendAnnotation
 	public void addPanelProvider(PanelProvider panelProvider) {
-		log.debug("added panel provider of type: " + panelProvider.getClass().getCanonicalName());
+		log.debug("added panel provider of type: {}", panelProvider.getClass().getCanonicalName());
 		panelProviders.add(panelProvider);
 	}
@@ -133,6 +134,7 @@
 	@AutoAppendAnnotation
 	public void addTree(Tree tree) {
-		log.debug("adding tree: " + tree);
+		log.debug("adding tree: {}", tree);
 		tree.setDispatcher(new SwingDispatcher<Tree>());
+		tree.setExceptionHandler(this);
 		trees.add(tree);
 	}
Index: java/main/src/main/java/com/framsticks/gui/EmptyPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/EmptyPanel.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/EmptyPanel.java	(revision 100)
@@ -1,5 +1,5 @@
 package com.framsticks.gui;
 
-import com.framsticks.params.AccessInterface;
+import com.framsticks.gui.tree.AbstractNode;
 
 /**
@@ -7,12 +7,8 @@
  */
 @SuppressWarnings("serial")
-public class EmptyPanel extends Panel {
+public class EmptyPanel extends AbstractPanel {
 
-	public EmptyPanel(Parameters parameters) {
-		super(parameters);
-	}
-
-	@Override
-	public void pullValuesFromLocalToUser(AccessInterface access) {
+	public EmptyPanel(Frame frame) {
+		super(frame);
 	}
 
@@ -21,3 +17,8 @@
 		return "Empty";
 	}
+
+	@Override
+	public void fillPanelWith(AbstractNode node) {
+
+	}
 }
Index: java/main/src/main/java/com/framsticks/gui/EmptyTreePanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/EmptyTreePanel.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/EmptyTreePanel.java	(revision 100)
@@ -0,0 +1,22 @@
+package com.framsticks.gui;
+
+import com.framsticks.params.Access;
+
+@SuppressWarnings("serial")
+public class EmptyTreePanel extends TreePanel {
+
+	public EmptyTreePanel(Parameters parameters) {
+		super(parameters);
+	}
+
+	@Override
+	public void pullValuesFromLocalToUser(Access access) {
+
+	}
+
+	@Override
+	public String getTitle() {
+		return "empty";
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/Frame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/Frame.java	(revision 100)
@@ -36,8 +36,10 @@
 import javax.swing.tree.TreeSelectionModel;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.core.Path;
 import com.framsticks.core.Tree;
+import com.framsticks.gui.tree.AbstractNode;
 import com.framsticks.gui.tree.MetaNode;
 import com.framsticks.gui.tree.TreeCellRenderer;
@@ -50,4 +52,5 @@
 import com.framsticks.util.dispatching.JoinableParent;
 import com.framsticks.util.dispatching.JoinableState;
+import com.framsticks.util.lang.Casting;
 import com.framsticks.util.swing.KeyboardModifier;
 import com.framsticks.util.swing.MenuConstructor;
@@ -59,5 +62,5 @@
 public class Frame extends FrameJoinable implements JoinableParent {
 
-	private static final Logger log = Logger.getLogger(Frame.class.getName());
+	private static final Logger log = LogManager.getLogger(Frame.class.getName());
 
 	protected final Browser browser;
@@ -89,4 +92,5 @@
 	protected JMenu windowMenu;
 	protected JMenu helpMenu;
+	protected EmptyPanel emptyPanel;
 
 	protected final Map<Tree, TreeAtFrame> treeAtFrames = new IdentityHashMap<>();
@@ -103,5 +107,13 @@
 		 * nor it can be removed in normal way through JSlider methods  */
 		UIManager.put("Slider.paintValue", false);
-		log.debug("creating " + this);
+		log.debug("creating {}", this);
+
+		cardPanel = new JPanel();
+		cardPanel.setName("card");
+
+		cardPanelLayout = new CardLayout();
+		cardPanel.setLayout(cardPanelLayout);
+
+		emptyPanel = new EmptyPanel(this);
 
 		Container contentPane = getSwing().getContentPane();
@@ -112,5 +124,5 @@
 		treePanel.setLayout(new BorderLayout());
 
-		rootNode = new MetaNode();
+		rootNode = new MetaNode(this);
 		rootNode.setName("root");
 		treeModel = new TreeModel(this);
@@ -139,5 +151,5 @@
 			@Override
 			public void treeExpanded(TreeExpansionEvent e) {
-				// loadChildren(treeModel.convertToPath(e.getPath()), false);
+				treeModel.expandTreeNode(e.getPath());
 			}
 		});
@@ -169,5 +181,5 @@
 			.join(KeyStroke.getKeyStroke('l'), KeyStroke.getKeyStroke(KeyEvent.VK_RIGHT, 0));
 
-		jtree.setCellRenderer(new TreeCellRenderer());
+		jtree.setCellRenderer(new TreeCellRenderer(treeModel));
 
 		treeScrollPane = new JScrollPane(jtree);
@@ -209,6 +221,4 @@
 		leftPanel.setForeground(Color.WHITE);
 
-		cardPanel = new JPanel();
-		cardPanel.setName("card");
 		JSplitPane split = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, leftPanel, cardPanel);
 		split.setPreferredSize(browser.defaultFrameDimension);
@@ -224,11 +234,9 @@
 		mainPanelLayout.show(mainPanel, "browser");
 
-		cardPanelLayout = new CardLayout();
-		cardPanel.setLayout(cardPanelLayout);
 
 		getSwing().pack();
 		jtree.requestFocusInWindow();
 
-		log.debug("frame configured: " + this);
+		log.debug("frame configured: {}", this);
 
 		new MenuConstructor(fileMenu).add(KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK), new AbstractAction("Close") {
@@ -258,5 +266,5 @@
 		Tree tree = path.getTree();
 
-		log.debug("trying mount: " + path);
+		log.debug("trying mount: {}", path);
 		if (!tree.getAssignedRoot().isResolved()) {
 			tree.get(path, new FutureHandler<Path>(this) {
@@ -274,16 +282,20 @@
 		TreeAtFrame e = new TreeAtFrame(tree, this);
 		treeAtFrames.put(tree, e);
-
-		rootNode.getChildren().add(new TreeNode(e, Path.to(tree, "/")));
+		Path rootPath = Path.to(tree, "/");
+
+		rootNode.getChildren().add(new TreeNode(e, rootPath));
 		e.rootNode = tree.getAssignedRoot();
-		treeModel.nodeStructureChanged(new TreePath(rootNode));
+		treeModel.treeStructureChanged(new TreePath(rootNode));
 		// jtree.expandPath(new TreePath(rootNode));
 	}
 
 
-	public void showPanel(Panel panel) {
+	public void showPanel(AbstractPanel panel) {
 		assert isActive();
 		assert panel != null;
+		log.debug("showing panel: {}", panel);
 		cardPanelLayout.show(cardPanel, panel.getUniqueName());
+
+		// cardPanel.revalidate();
 	}
 
@@ -297,4 +309,7 @@
 
 		Path path = treeModel.convertToPath(treePath);
+		if (path == null) {
+			return;
+		}
 		treePopupMenu.removeAll();
 
@@ -311,9 +326,28 @@
 	}
 
-	public void updatePanelIfIsLeadSelection(TreePath treePath, Path path) {
+	public void updatePanelIfIsLeadSelection(Path path) {
 		assert isActive();
+		TreePath treePath = treeModel.convertToTreePath(path, true);
+		if (treePath == null) {
+			return;
+		}
 		if (treePath.equals(jtree.getSelectionPath())) {
-			treeAtFrames.get(path.getTree()).useOrCreatePanel(treePath);
-		}
+			log.debug("updating: {} -> {}", treePath, path);
+			showPanelForTreePath(treePath);
+		}
+	}
+
+	public void showPanelForTreePath(TreePath treePath) {
+		assert isActive();
+		AbstractNode node = Casting.assertCast(AbstractNode.class, treePath.getLastPathComponent());
+
+		AbstractPanel panel = node.getPanel();
+		if (panel == null) {
+			log.error("no panel for {} found", treePath);
+			return;
+		}
+		panel.fillPanelWith(node);
+		showPanel(panel);
+		// cardPanel.revalidate();
 	}
 
@@ -323,5 +357,4 @@
 	//	assert isActive();
 	//	final TreePath treePath = treeModel.convertToTreePath(path);
-	//	log.info("go to path: " + path + "(" + treePath + ")");
 
 	//	this.dispatch(new RunAt<Frame>(this) {
@@ -394,4 +427,11 @@
 
 	/**
+	 * @return the emptyPanel
+	 */
+	public EmptyPanel getEmptyPanel() {
+		return emptyPanel;
+	}
+
+	/**
 	 * @return the treeAtFrames
 	 */
Index: java/main/src/main/java/com/framsticks/gui/FrameJoinable.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/FrameJoinable.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/FrameJoinable.java	(revision 100)
@@ -10,5 +10,6 @@
 import javax.swing.UIManager;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.util.FramsticksException;
@@ -19,5 +20,5 @@
 public abstract class FrameJoinable extends SwingJoinable<JFrame> implements ExceptionResultHandler {
 	private static final Logger log =
-		Logger.getLogger(FrameJoinable.class);
+		LogManager.getLogger(FrameJoinable.class);
 
 	protected String title;
@@ -65,5 +66,5 @@
 						boolean found = false;
 						// for (LookAndFeelInfo info : UIManager.getInstalledLookAndFeels()) {
-						//	log.info("look and feel available: " + info.getName());
+						//	log.info("look and feel available: {}", info.getName());
 						//	if ("Nimbus".equals(info.getName())) {
 						//		UIManager.setLookAndFeel(info.getClassName());
@@ -109,5 +110,5 @@
 	protected void joinableFinish() {
 		super.joinableFinish();
-		log.debug("disposing frame " + this);
+		log.debug("disposing frame {}", this);
 		getSwing().dispose();
 	}
Index: java/main/src/main/java/com/framsticks/gui/Gui.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/Gui.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/Gui.java	(revision 100)
@@ -10,5 +10,6 @@
 import javax.swing.JPanel;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.gui.controls.CheckBoxControl;
@@ -39,5 +40,5 @@
 public final class Gui {
 
-	private static final Logger log = Logger.getLogger(Gui.class.getName());
+	private static final Logger log = LogManager.getLogger(Gui.class.getName());
 
 	private Gui() {
@@ -117,5 +118,5 @@
 			control.setOwner(owner);
 
-			log.debug("add component for " + param);
+			log.debug("add component for {}", param);
 			JPanel line = new JPanel();
 			line.setLayout(new BoxLayout(line, BoxLayout.LINE_AXIS));
Index: java/main/src/main/java/com/framsticks/gui/ImageProvider.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/ImageProvider.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/ImageProvider.java	(revision 100)
@@ -4,5 +4,6 @@
 package com.framsticks.gui;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import javax.swing.*;
@@ -16,5 +17,5 @@
 public class ImageProvider {
 
-	private final static Logger log = Logger.getLogger(ImageProvider.class.getName());
+	private final static Logger log = LogManager.getLogger(ImageProvider.class.getName());
 
 
@@ -87,5 +88,5 @@
 			return icon;
 		} catch (Exception ignored) {
-			log.error("failed to read icon: " + resourceName);
+			log.error("failed to read icon: {}", resourceName);
 		}
 		return null;
Index: java/main/src/main/java/com/framsticks/gui/MainFrame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/MainFrame.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/gui/MainFrame.java	(revision 100)
@@ -11,5 +11,6 @@
 import javax.swing.WindowConstants;
 
-import org.apache.log4j.Logger;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
 
 import com.framsticks.util.swing.MenuConstructor;
@@ -21,5 +22,5 @@
 public class MainFrame extends Frame {
 
-	private final static Logger log = Logger.getLogger(MainFrame.class.getName());
+	private final static Logger log = LogManager.getLogger(MainFrame.class.getName());
 
 	JButton start, stop, step;
@@ -127,8 +128,8 @@
 	// 	// 			public void call(Exception e) {
 	// 	// 				if (e != null) {
-	// 	// 					log.error("failed to resolve: " + s);
+	// 	// 					log.error("failed to resolve: {}", s);
 	// 	// 					return;
 	// 	// 				}
-	// 	// 				log.info("succeeded to resolve: " + s);
+	// 	// 				log.info("succeeded to resolve: {}", s);
 	// 	// 			}
 	// 	// 		});
